;#############################################################
; BBSOPLOT  written by: Anders Johannesson,
;                       Big Bear Solar Observatory  Aug. 96
;#############################################################



; CODE MODIFICATIONS MADE ABOVE THIS COMMENT WILL BE LOST.
; DO NOT REMOVE THIS COMMENT: BEGIN HEADER




; DO NOT REMOVE THIS COMMENT: END HEADER
; CODE MODIFICATIONS MADE BELOW THIS COMMENT WILL BE LOST.


; CODE MODIFICATIONS MADE ABOVE THIS COMMENT WILL BE LOST.
; DO NOT REMOVE THIS COMMENT: BEGIN BBSOPLOT




PRO BBSOPLOT_Event, Event

  COMMON plotdata, x_arr, arr, p_type, x_title, y_title, oldplot
  COMMON DRAW10_Comm, DRAW10_Id

  WIDGET_CONTROL,GET_UVALUE = state, event.top, /NO_COPY

  CASE Event.Id OF

  state.bsavemenu: BEGIN
      CASE Event.Value OF
         'Save.in ASCII table' :BEGIN
              outfile=pickfile(FILTER='*.txt',TITLE='Select ASCII file for output')
              if strlen(outfile) gt 1 then begin
                 openw,fp,outfile,/GET_LUN
                 for i=0,n_elements(arr)-1 do begin
                    printf,fp,x_arr(i),arr(i)
                 endfor
                 FREE_LUN,fp
              end
              END
         'Save.in IDL xdr file' :BEGIN
              outfile=pickfile(FILTER='*.xdr',TITLE='Select IDL XDR file for output')
              if strlen(outfile) gt 1 then begin
                 bbsofits_data=[[x_arr],[arr]] 
                 save,file=outfile,bbsofits_data
              end            
              END
      ENDCASE
      WIDGET_CONTROL, SET_UVALUE = state, event.top, /NO_COPY
      END
  state.bapply: BEGIN
      WIDGET_CONTROL,state.x1,Get_Value=x1
      WIDGET_CONTROL,state.x2,Get_Value=x2
      WIDGET_CONTROL,state.y1,Get_Value=y1
      WIDGET_CONTROL,state.y2,Get_Value=y2
      fx1=float(x1) & fx2=float(x2)
      fy1=float(y1) & fy2=float(y2)
      wset,DRAW10_Id
      if strpos(p_type,'HISTOGRAM') lt 0 then begin
         plot,x_arr,arr,xrange=[fx1,fx2],yrange=[fy1,fy2],charsize=1.0,$
         xtitle=x_title, ytitle=y_title,$
         xstyle=1,ystyle=1
      endif else begin
         plot,x_arr,arr,xrange=[fx1,fx2],yrange=[fy1,fy2],charsize=1.0,$
         xtitle=x_title, ytitle=y_title,$
         xstyle=1,ystyle=1,psym=10
      endelse
      wset,oldplot
      WIDGET_CONTROL, SET_UVALUE = state, event.top, /NO_COPY
      END
  state.bprint: BEGIN
      ;# GET FILE NAME
      WIDGET_CONTROL, /HOURGLASS
      printfile=pickfile(FILTER='*.ps')
      WIDGET_CONTROL, /HOURGLASS
      if strlen(printfile) gt 1 then begin
         olddev=!d.name
         set_plot,'ps'
         device,file=printfile,/palatino,xoffset=0.75,yoffset=3,/inches
         WIDGET_CONTROL,state.x1,Get_Value=x1
         WIDGET_CONTROL,state.x2,Get_Value=x2
         WIDGET_CONTROL,state.y1,Get_Value=y1
         WIDGET_CONTROL,state.y2,Get_Value=y2
         fx1=float(x1) & fx2=float(x2)
         fy1=float(y1) & fy2=float(y2)
         if strpos(p_type,'HISTOGRAM') lt 0 then begin
            plot,x_arr,arr,xrange=[fx1,fx2],yrange=[fy1,fy2],$
            title='BBSOFITS  '+p_type+'   '+systime(0),$
            xtitle=x_title, ytitle=y_title,$
            xstyle=1,ystyle=1,$
            FONT=0
         endif else begin
            plot,x_arr,arr,xrange=[fx1,fx2],yrange=[fy1,fy2],$
            title='BBSOFITS  '+p_type+'   '+systime(0),$
            xtitle=x_title, ytitle=y_title,$
            xstyle=1,ystyle=1,$
            FONT=0,psym=10
         endelse
         device,/close
         set_plot,olddev
      endif
      WIDGET_CONTROL, SET_UVALUE = state, event.top, /NO_COPY
      END
  state.bquit: BEGIN
      WIDGET_CONTROL,event.top,/destroy
      END
  ELSE:

  ENDCASE
END


; DO NOT REMOVE THIS COMMENT: END BBSOPLOT
; CODE MODIFICATIONS MADE BELOW THIS COMMENT WILL BE LOST.



PRO bbsoplot, xarr, array, limits, caption, GROUP=Group

  IF(XRegistered("BBSOPLOT") NE 0) THEN return

  COMMON plotdata, x_arr, arr, p_type, x_title, y_title, oldplot

  ;# DEFAULTS
  x1=limits(0)
  x2=limits(1)
  y1=limits(2)
  y2=limits(3)
  x_arr=xarr
  arr=array
  p_type=caption(0)
  x_title=caption(1)
  y_title=caption(2)
  oldplot=!D.window

  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }

  BBSOPLOT = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      UVALUE='BBSOPLOT',$
      TITLE=' BBSOFITS  '+p_type,$
      XOFFSET=400, YOFFSET=100)

  BASE45 = WIDGET_BASE(BBSOPLOT, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE45')

  BASE3 = WIDGET_BASE(BASE45, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE3')

  MenuDescSAVE = [ $
      { CW_PDMENU_S,     3, 'Save' }, $
        { CW_PDMENU_S,     0, 'in ASCII table' }, $
        { CW_PDMENU_S,     2, 'in IDL xdr file' } $
  ]
  SAVEMENU = CW_PDMENU(BASE3, MenuDescSAVE, /RETURN_FULL_NAME, $
             UVALUE='SAVEMENU')

  FieldVal5933 = [ string(x1) ]
  FIELD38 = CW_FIELD( BASE3,VALUE=FieldVal5933, $
      ROW=1, $
      STRING=1, $
      TITLE='x1', $
      UVALUE='FIELD38', $
      XSIZE=9)

  FieldVal5935 = [ string(x2) ]
  FIELD39 = CW_FIELD( BASE3,VALUE=FieldVal5935, $
      ROW=1, $
      STRING=1, $
      TITLE='x2', $
      UVALUE='FIELD39', $
      XSIZE=9)

  FieldVal5937 = [ string(y1) ]
  FIELD40 = CW_FIELD( BASE3,VALUE=FieldVal5937, $
      ROW=1, $
      STRING=1, $
      TITLE='y1', $
      UVALUE='FIELD40', $
      XSIZE=9)

  FieldVal5939 = [ string(y2) ]
  FIELD41 = CW_FIELD( BASE3,VALUE=FieldVal5939, $
      ROW=1, $
      STRING=1, $
      TITLE='y2', $
      UVALUE='FIELD41', $
      XSIZE=9)

  BUTTON42 = WIDGET_BUTTON( BASE3, $
      UVALUE='BUTTON42', $
      VALUE='Apply')

  BUTTON47 = WIDGET_BUTTON( BASE3, $
      UVALUE='BUTTON47', $
      VALUE='Print')

  BUTTON43 = WIDGET_BUTTON( BASE3, $
      UVALUE='BUTTON43', $
      VALUE='Quit')

  BASE9 = WIDGET_BASE(BBSOPLOT, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE9')

  DRAW10 = WIDGET_DRAW( BASE9, $
      RETAIN=2, $
      UVALUE='DRAW10', $
      XSIZE=566, $
      YSIZE=512)

  ;# DEFINE WIDGET ID ARRAY
  state = {bapply : BUTTON42, bprint : BUTTON47, bquit : BUTTON43,$
           x1 : FIELD38, x2 : FIELD39, $
           y1 : FIELD40, y2 : FIELD41, $
           bsavemenu : SAVEMENU}

  WIDGET_CONTROL, BBSOPLOT, /REALIZE
  WIDGET_CONTROL, BBSOPLOT, SET_UVALUE=state

  ; Get drawable window index

  COMMON DRAW10_Comm, DRAW10_Id
  WIDGET_CONTROL, DRAW10, GET_VALUE=DRAW10_Id

  if strpos(p_type,'HISTOGRAM') lt 0 then begin
     plot,x_arr,arr,xrange=[x1,x2],yrange=[y1,y2],charsize=1.0,$
     xtitle=x_title, ytitle=y_title,$
     xstyle=1,ystyle=1
  endif else begin
     plot,x_arr,arr,xrange=[x1,x2],yrange=[y1,y2],charsize=1.0,$
     xtitle=x_title, ytitle=y_title,$
     xstyle=1,ystyle=1,psym=10
  endelse
  wset,oldplot

  XMANAGER, 'BBSOPLOT', BBSOPLOT
END
